function loadLevelEditor()
		timer3=0
		game = {}
		game.screen_width = 1920
		game.screen_height = 1080
		
		--fonts

poorfish = love.graphics.newFont("fonts/PoorFish/PoorFish-Regular.otf", 84) -- Thanks @hicchicc for the font
poorfishmiddle = love.graphics.newFont("fonts/PoorFish/PoorFish-Regular.otf", 64) -- Thanks @hicchicc for the font
poorfishsmall = love.graphics.newFont("fonts/PoorFish/PoorFish-Regular.otf", 32) -- Thanks @hicchicc for the font

KeyIcon =  love.graphics.newImage("assets/KeyIcon.png")
MouseLine =  love.graphics.newImage("assets/Mouse.png")

love.window.setMode(1920, 1080, {resizable = true, borderless = false})

require ('editor/leveleditor_draw_Objects') 	-- this file show the path where the custom level is saved
Initialize_Objects()

require ('editor/leveleditorButtons') 	-- this file show the path where the custom level is saved
loadLevelEditorButtons()

require ('editor/leveleditorExportFolder') 	-- this file show the path where the custom level is saved
loadExportdata()

require ('editor/levelEditor_Load_levels') 	-- this file load custom levels

require ('editor/levelEditor_Play_level') 	-- this file load custom levels

require ('editor/keyinputLevelEditor')

require ('editor/Export2Graphics')


-- Define your grid and palette
gridSize = 20
grid = {}  -- 2D array representing the grid
currentTile = 1  -- The currently selected tile from the palette

    -- Initialize the grid with empty cells
    for x = 1, gridSize do
        grid[x] = {}
        for y = 1, gridSize do
            grid[x][y] = 0  -- 0 represents an empty cell
        end
    end

    -- Define a global 'level' variable
    level = {}

    -- Initialize level properties
    level.map = {}  -- Initialize the map as an empty table
    level.agents = {}  -- Initialize agents as an empty table
    level.objects = {}  -- Initialize objects as an empty table
    level.areas = {}  -- Initialize exit area
    
    agent1Added = false
	agent2Added = false
	
	
	typingGridSize=false	-- Variable to check if typing grid size mode is activated
	
	gridSizeInput = ""  -- Variable to store the user input for grid size
	
	newSize=0	-- Initialize variable to type grid size
	
	local isDrawingObject = false
	timer2=0
	timer3=0
	emulatedmousex=0
	emulatedmousey=0
	pulsateTimer=0
	scalefactor=1
	gamestatus="levelEditor"


levelEditorHelp = [[
Shortcuts:

1 draw walls
2 draw border
3 draw empty cell (delete walls)
4 draw agent 1
5 draw agent 2
6 draw exit
7 draw object
e export the maze.

Use the mouse to draw the maze.
]]

drawingMode = "wall"  -- Initialize with "wall" drawing mode
end

function initializeGridLevelEditor()

    -- Initialize the grid with empty cells
    for x = 1, gridSize do
        grid[x] = {}
        for y = 1, gridSize do
            grid[x][y] = 0  -- 0 represents an empty cell
        end
    end
end

function updateLevelEditor(dt)
	
	timer3=timer3+dt
	if timer3>5 then
			showExportPath=false
	end
	
	love.mousepressed(x, y, button, istouch, presses)
	
	--if showCustomLevels then
        --updateMenu(dt)
    --end
	
end

function love.mousemoved(x, y, dx, dy, istouch)
    if gamestatus == "levelEditor" and love.mouse.isDown(1) then
        local cellX = math.floor(x / 32) + 1
        local cellY = math.floor(y / 32) + 1

        if cellX >= 1 and cellX <= gridSize and cellY >= 1 and cellY <= gridSize then
            if drawingMode == "wall" then
                grid[cellX][cellY] = 1
            elseif drawingMode == "agent" then
                addAgent(cellX, cellY)
            elseif drawingMode == "agent2" then
                addAgent2(cellX, cellY)
            elseif drawingMode == "exit" then
                addExitArea(cellX, cellY)
            elseif drawingMode == "border" then
                grid[cellX][cellY] = 3
            elseif drawingMode == "emptyCell" then
                grid[cellX][cellY] = 0
            end

            if drawingMode == "object" then
                if isMovingObject then
                    moveObject(currentObject, cellX, cellY)
                elseif isDrawingObject then
                    -- Update the object's form based on mouse movement
                    if currentObject==nil then
						love.graphics.print ("Error no current object:", game.screen_width-800,400,0, 0.8, 1)
                    else
                    updateObjectForm(currentObject.form, cellX, cellY)
                    end
                elseif isPlacingObject then
                   if currentObject==nil then
						love.graphics.print ("Error no current object:", game.screen_width-800,400,0, 0.8, 1)
                    else
						currentObject.x = cellX
						currentObject.y = cellY
					end
                end
            end
        end
    end
end





function addAgentAtMouse(x, y)
    local cellX = math.floor(x / 32) + 1
    local cellY = math.floor(y / 32) + 1

    if cellX >= 1 and cellX <= gridSize and cellY >= 1 and cellY <= gridSize then
			if drawingMode == "agent" then
				addAgent(cellX, cellY)
		elseif drawingMode == "agent" then
				addAgent2(cellX, cellY)
		end
    end
end



function addExitAreaAtMouse(x, y)
    local cellX = math.floor(x / 32) + 1
    local cellY = math.floor(y / 32) + 1

    if cellX >= 1 and cellX <= gridSize and cellY >= 1 and cellY <= gridSize then
        addExitArea(cellX, cellY)
    end
end


function love.textinput(text)
    if not (gridSizeInput==nil) then 
		gridSizeInput = gridSizeInput .. text  -- Append typed characters to the input string
	end
end


function setGridSize(newSize)
    gridSize = newSize
    grid = {}
    currentTile = 1

    -- Initialize the grid with empty cells
    for x = 1, gridSize do
        grid[x] = {}
        for y = 1, gridSize do
            grid[x][y] = 0  -- 0 represents an empty cell
        end
    end
end

function drawGrid()
    -- Draw the grid lines
    for x = 1, gridSize do
        love.graphics.line((x - 1) * 32, 0, (x - 1) * 32, gridSize * 32)
    end
    for y = 1, gridSize do
        love.graphics.line(0, (y - 1) * 32, gridSize * 32, (y - 1) * 32)
    end
end

-- Helper function to add an agent at a given cell
function addAgent(cellX, cellY)
    for _, agent in ipairs(level.agents) do
        if agent.name == "fish-4x2" then
            -- Agent of type "fish-4x2" already exists, replace it
            agent.x = cellX
            agent.y = cellY
            return  -- Exit the function, as we don't need to insert a new agent
        end
    end

    -- If no agent of this type exists, create a new one
    local agent = {
        name = "fish-4x2",
        fish = true,
        heavy = false,
        x = cellX,
        y = cellY,
        form = {
            {1, 1, 1},
            {1, 1, 1},
        },
    }

    table.insert(level.agents, agent)
end

function addAgent2(cellX, cellY)
    for _, agent in ipairs(level.agents) do
        if agent.name == "fish-3x1" then
            -- Agent of type "fish-3x1" already exists, replace it
            agent.x = cellX
            agent.y = cellY
            return  -- Exit the function, as we don't need to insert a new agent
        end
    end

    -- If no agent of this type exists, create a new one
    local agent = {
        name = "fish-3x1",
        fish = true,
        heavy = false,
        x = cellX,
        y = cellY,
        form = {
            {1, 1, 1},
        },
    }

    table.insert(level.agents, agent)
end



-- Helper function to add an exit area and update the grid
function addExitArea(cellX, cellY)
    if cellX >= 1 and cellX <= gridSize and cellY >= 1 and cellY <= gridSize then
        grid[cellX][cellY] = 6  -- Set grid cell to indicate an exit area
    end

    local exitArea = {
        name = "exit",
        x = cellX,
        y = cellY,
        w = 1,  -- Adjust the width and height as needed
        h = 1,
    }
    table.insert(level.areas, exitArea)
end


function drawLevelEditor()
--print("Drawing Mode: " .. drawingMode)
--print("isDrawingObject: " .. tostring(isDrawingObject))
--print("isMovingObject: " .. tostring(isMovingObject))

if drawingMode=="object" then
	love.graphics.setFont( poorfishsmall )
	love.graphics.setColor(1,1,1,1)
	love.graphics.print ("Info for debuging, this feature is a work in progres and may not work as expected:", game.screen_width-800,100,0, 0.8, 1)
	love.graphics.print ("Drawing Mode:" .. drawingMode, game.screen_width-800,150,0, 0.8, 1)
	love.graphics.print ("isDrawingObject:" .. tostring(isDrawingObject), game.screen_width-800,200,0, 0.8, 1)
	love.graphics.print ("isMovingObject:" .. tostring(isMovingObject), game.screen_width-800,250,0, 0.8, 1)
	love.graphics.print ("isPlacingObject:" .. tostring(isPlacingObject), game.screen_width-800,300,0, 0.8, 1)
	love.graphics.print ("Current object:" .. tostring(currentObject), game.screen_width-800,350,0, 0.8, 1)
	
	love.graphics.setFont( poorfish )
	
end



    -- Draw the grid lines
    love.graphics.setColor(0.5, 0.5, 0.5)  -- Set grid color (gray)
    for x = 1, gridSize + 1 do
        love.graphics.line((x - 1) * 32, 0, (x - 1) * 32, gridSize * 32)
    end
    
    for y = 1, gridSize + 1 do
        love.graphics.line(0, (y - 1) * 32, gridSize * 32, (y - 1) * 32)
    end
    love.graphics.setColor(1, 1, 1)  -- Reset color to white

    -- Draw the grid
    for x = 1, gridSize do
        for y = 1, gridSize do
            local cellType = grid[x][y]
            -- Draw cells based on their type
            if cellType == 1 then	-- walls
                love.graphics.setColor(1,1,1)	-- white
                love.graphics.rectangle("fill", (x - 1) * 32, (y - 1) * 32, 32, 32)
            elseif cellType == 3 then	-- borders
                love.graphics.setColor(0, 0, 128 / 255)
                love.graphics.rectangle("fill", (x - 1) * 32, (y - 1) * 32, 32, 32)
                love.graphics.setColor(1, 1, 1)
            elseif cellType == 6 then	-- exit areas
				love.graphics.setColor(1, 236 / 255, 139 / 255)	-- harmonious yellow
                love.graphics.rectangle("fill", (x - 1) * 32, (y - 1) * 32, 32, 32)
                love.graphics.setColor(1, 1, 1)
            end
            
            
	--[[gridElementColor=
	{
		{66, 66, 66},						--Walls: Dark Gray					1
		{0, 0, 128},						--Borders: Navy Blue				2
		{ 65, 105, 225},					--Agent 1: Royal Blue				3
		{255, 69, 0},						--Agent 2: Orange Red				4
		{152 / 255, 251 / 255, 152 / 255},	--Light Objects: Light Yellow		5
		{139, 69, 19},						--Heavy Objects: Dark Brown			6
		{128, 0, 128}						--Exit Area: Purple					7
		
		{152 / 255, 251 / 255, 152 / 255}  -- Light Green (Harmonious with the palette) light objects

	}--]]


           -- Draw agents with different colors
for _, agent in ipairs(level.agents) do
    if agent.name == "fish-4x2" then
        love.graphics.setColor(65 / 255, 105 / 255, 225 / 255)  --Agent 1: Royal Blue
    elseif agent.name == "fish-3x1" then
        love.graphics.setColor(255 / 255, 69 / 255, 0)  -- Set color for agent 2 (green)
    end
    
    for i = 1, #agent.form do
        for j = 1, #agent.form[i] do
            if agent.form[i][j] == 1 then
                local cellX = agent.x + j - 1
                local cellY = agent.y + i - 1
                love.graphics.rectangle("fill", (cellX - 1) * 32, (cellY - 1) * 32, 32, 32)
            end
        end
    end
 end  
 
 if drawingMode == "object" then
 
    for _, object in ipairs(level.objects) do
        -- Set the appropriate color for objects
        local objectColor = {139 / 255, 69 / 255, 19 / 255}  -- Default color (white) for objects

        -- Set the object color based on type (light or heavy)
        if object.heavy then
            objectColor = {139 / 255, 69 / 255, 19 / 255}  -- Dark Brown for heavy objects
        else
            objectColor = {152 / 255, 251 / 255, 152 / 255}  -- Light Yellow for light objects
        end

        love.graphics.setColor(unpack(objectColor))

        for i = 1, #object.form do
            for j = 1, #object.form[i] do
                if object.form[i][j] == 1 then
                    local cellX = (object.x + j - 1) * 32  -- Calculate the X position
                    local cellY = (object.y + i - 1) * 32  -- Calculate the Y position
                    love.graphics.rectangle("fill", cellX, cellY, 32, 32)  -- Draw the object

                    -- Highlight the borders for heavy objects
                    if object.heavy then
                        love.graphics.setColor(0, 0, 128 / 255)  -- Navy Blue for borders
                        love.graphics.rectangle("line", cellX, cellY, 32, 32)  -- Draw border
                        love.graphics.setColor(unpack(objectColor))  -- Reset color
                    end
                end
            end
        end
    end
end



    love.graphics.setColor(1, 1, 1)  -- Reset color to white
        end
    end

    --drawLevelEditorHelp()
	drawObjectHelp()
    love.graphics.setFont( poorfishsmall )
    if not (drawingMode=="object") then
			love.graphics.print ("Drawing:" .. drawingMode, TypeGridSizeButton.x+50,TypeGridSizeButton.y+60,0, 0.8, 1)
	elseif drawingMode=="object" then
				if isDrawingObject then
					love.graphics.print ("Drawing object:", TypeGridSizeButton.x+50,TypeGridSizeButton.y+60,0, 0.8, 1)
			elseif isMovingObject then
					love.graphics.print ("Moving object:", TypeGridSizeButton.x+50,TypeGridSizeButton.y+60,0, 0.8, 1)
			end
	end
        
    drawLevelEditorButtons()
    fadesExportInformation() -- render the path and button to access the saved custom level

end


		local desktopWidth, desktopHeight = love.window.getDesktopDimensions()
		
function drawObjectHelp()
	 if not (objectHelpShowed) then
		love.graphics.setFont( poorfishsmall )
		if drawingMode=="object" then
			love.graphics.setColor(1,1,1,0.5*(5-timer3))
			love.graphics.draw(MouseLine, game.screen_width-200,game.screen_height-900,0,0.2)
				love.graphics.print ("Draw an object in 2 steps:", game.screen_width-500,game.screen_height-800,0, 0.8, 1)
				love.graphics.print ("1. Draw the form of the object", game.screen_width-500,game.screen_height-750,0, 0.8, 1)
				love.graphics.print ("Left mouse button: draw object", game.screen_width-450,game.screen_height-700,0, 0.8, 1)
				love.graphics.print ("Right mouse button: Finalize drawing", game.screen_width-450,game.screen_height-650,0, 0.8, 1)
				love.graphics.print ("2. Place the object in the grid", game.screen_width-500,game.screen_height-600,0, 0.8, 1)
				love.graphics.print ("Left mouse button: Move the object", game.screen_width-450,game.screen_height-550,0, 0.8, 1)
				love.graphics.print ("Right mouse button: Place it", game.screen_width-450,game.screen_height-500,0, 0.8, 1)
		love.graphics.setColor(1,1,1,1)
		end
	end
end

function drawLevelEditorHelp()
	
			love.graphics.setFont( poorfishsmall )
			love.graphics.print ("Drawing:" .. drawingMode, TypeGridSizeButton.x+50,TypeGridSizeButton.y+60,0, 0.8, 1)
			

			love.graphics.setColor(0.5,0.5,0.5,0.8)
			love.graphics.rectangle('fill',890,700,1000,500)
			love.graphics.setColor(1,1,1)
			
				
				love.graphics.print(levelEditorHelp,900,700,0, 0.8, 1)
				
		drawLevelEditorButtons()
		
end

function exportLevel()
    -- Generate Lua code to represent the current level
    local levelCode = "level.map = {\n"
    for y = 1, gridSize do
        levelCode = levelCode .. "    {"
        for x = 1, gridSize do
            levelCode = levelCode .. grid[x][y]
            if x < gridSize then
                levelCode = levelCode .. ","
            end
        end
        levelCode = levelCode .. "}"
        if y < gridSize then
            levelCode = levelCode .. ","
        end
        levelCode = levelCode .. "\n"
    end
    levelCode = levelCode .. "}\n"

    -- Add agent, object, and exit area data
    levelCode = levelCode .. "level.agents = {\n"
    for _, agent in ipairs(level.agents) do
        levelCode = levelCode .. "    {name = '" .. agent.name .. "', fish = " .. tostring(agent.fish) ..
                    ", heavy = " .. tostring(agent.heavy) .. ", x = " .. agent.x .. ", y = " .. agent.y ..
                    ", form = {\n"
        for i, row in ipairs(agent.form) do
            levelCode = levelCode .. "        {" .. table.concat(row, ",") .. "}"
            if i < #agent.form then
                levelCode = levelCode .. ","
            end
            levelCode = levelCode .. "\n"
        end
        levelCode = levelCode .. "    }},\n"
    end
    levelCode = levelCode .. "}\n"

    levelCode = levelCode .. "level.objects = {\n"
    for _, object in ipairs(level.objects) do
        levelCode = levelCode .. "    {name = '" .. object.name .. "', heavy = " .. tostring(object.heavy) ..
                    ", x = " .. object.x .. ", y = " .. object.y .. ", form = {\n"
        for i, row in ipairs(object.form) do
            levelCode = levelCode .. "        {" .. table.concat(row, ",") .. "}"
            if i < #object.form then
                levelCode = levelCode .. ","
            end
            levelCode = levelCode .. "\n"
        end
        levelCode = levelCode .. "    }},\n"
    end
    levelCode = levelCode .. "}\n"

    -- Save the generated code to a file
    love.filesystem.write("customlevel.lua", levelCode)

    print("Level code saved to customlevel.lua")
    Acceptsound:play()
    levelexported=true
end

